import React, { Component } from "react";
import ReactDOM from "react-dom";
import { SpreadSheets, Worksheet } from "@grapecity/spread-sheets-react";
import * as GC from "@grapecity/spread-sheets";
import "@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css";

import "./styles.css";

GC.Spread.Sheets.LicenseKey = window["evalKey_V13"];

class App extends Component {
  constructor() {
    super();
    this.state = {};

    this.hostStyle = {
      width: "100%",
      height: "600px"
    };

    this.spread = null;
    this.file = null;
  }
  addTable(sheet) {
    //This example creates a table.
    var spreadNS = GC.Spread.Sheets;
    var source = [
        { Course: "Calculus", Term: 1, Credit: 5, Score: 80, Teacher: "Nancy.Feehafer" },
        { Course: "P.E.", Term: 1, Credit: 3.5, Score: 85, Teacher: "Andrew.Cencini" },
        { Course: "Political Economics", Term: 1, Credit: 3.5, Score: 95, Teacher: "Jan.Kotas" },
        { Course: "Basic of Computer", Term: 1, Credit: 2, Score: 85, Teacher: "Steven.Thorpe" },
        { Course: "Micro-Economics", Term: 1, Credit: 4, Score: 62, Teacher: "Jan.Kotas" },
        { Course: "Linear Algebra", Term: 2, Credit: 5, Score: 73, Teacher: "Nancy.Feehafer" },
        { Course: "Accounting", Term: 2, Credit: 3.5, Score: 86, Teacher: "Nancy.Feehafer" },
        { Course: "Statistics", Term: 2, Credit: 5, Score: 85, Teacher: "Robert.Zare" },
        { Course: "Marketing", Term: 2, Credit: 4, Score: 70, Teacher: "Laura.Giussani" }
    ];
    var table = sheet.tables.addFromDataSource("Table1", 2, 1, source, spreadNS.Tables.TableThemes.medium2);
  }

  workbookInitialized = spread => {
    // save spread instance for future references
    this.spread = spread;

    // init spread
    var sheet = spread.getActiveSheet();
    sheet.setColumnWidth(3, 120);
    this.addTable(sheet);
  };

  render() {
    return (
      <div className="App">
        <h1>Hello SpreadJS</h1>
        <SpreadSheets
          hostStyle={this.hostStyle}
          workbookInitialized={this.workbookInitialized}
        >
          <Worksheet />
        </SpreadSheets>
      </div>
    );
  }
}

const rootElement = document.getElementById("root");
ReactDOM.render(<App />, rootElement);
